//     ======================= AssociativeMemory.h ==========================
//     **********************************************************************
//     Author: Yeremeyev Dmitriy Vladimirovich *** mailto:edvmail@mail.ru
//     Last update : 31.10.2007
//     **********************************************************************

#if !defined(_AssociativeMemory_H_INCLUDED_)
#define _AssociativeMemory_H_INCLUDED_

#include "cv.h"
#include "cxmisc.h"

// Definition of object recognition function
typedef void (*TYPE_RcgAMFunc16S)(int* apData, CvRect aObjRect,
								  uint64 aIndex, uint64 aHitCounter, void* args);
typedef TYPE_RcgAMFunc16S CvRcgAMFunc16S;

// Associative memory class for integer data
class CvAssociativeMemory16S {
	void* p;
public:

	CvAssociativeMemory16S();
	~CvAssociativeMemory16S();
	
	// Creating of associative memory
	bool Create(CvSize aKeyImgSize, CvMemStorage*  apMemStorage, short aLevelMax = 0);

	// Set an image for processing
	void SetImage(const void* apSrcImg);

	// Reading from associative memory cell (associative base)
	bool Read(CvRect aInterestArea, int** appData,
		      uint64* apIndex = NULL, uint64* apHitCounter = NULL);

	// Writing to associative memory cell
	void Write(CvRect aInterestArea, int* apData);

	// Object recognition
	void Recognition(CvRcgAMFunc16S RcgAMFunc, void *args = NULL);

	// Saving of recognition data
	bool Save(char* aFileName);
	// Loading of recognition data
	bool Load(char* aFileName);
	
	// Get current index of associative base
	uint64 GetCurIndex();
	// Get total number of associative bases
	long   GetTotalABases();
	// Get total number of memory levels
	short  GetTotalLevels();
};

#endif // !defined(_AssociativeMemory_H_INCLUDED_)
